"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.kind = exports.has = exports.isArray = exports.isInstance = exports.isFunction = exports.isNil = exports.isNull = exports.isUndefined = exports.isSymbol = exports.isBoolean = exports.isBigInt = exports.isNumber = exports.isString = void 0;
function isString(value) {
    return typeof value === 'string';
}
exports.isString = isString;
function isNumber(value) {
    return typeof value === 'number';
}
exports.isNumber = isNumber;
function isBigInt(value) {
    return typeof value === 'bigint';
}
exports.isBigInt = isBigInt;
function isBoolean(value) {
    return typeof value === 'boolean';
}
exports.isBoolean = isBoolean;
function isSymbol(value) {
    return typeof value === 'symbol';
}
exports.isSymbol = isSymbol;
function isUndefined(value) {
    return value === undefined;
}
exports.isUndefined = isUndefined;
function isNull(value) {
    return value === null;
}
exports.isNull = isNull;
function isNil(value) {
    return value == null;
}
exports.isNil = isNil;
function isFunction(value) {
    return typeof value === 'function';
}
exports.isFunction = isFunction;
function isInstance(value, C) {
    return value instanceof C;
}
exports.isInstance = isInstance;
/**
 *  This will not check element types.
 */
function isArray(value) {
    return Array.isArray(value);
}
exports.isArray = isArray;
function has(...args) {
    return function (value) {
        return args.every((k) => !isNil(value[k]));
    };
}
exports.has = has;
function kind(uid, uniProp = 'kind') {
    return function (value) {
        return isString(value[uniProp]) && value[uniProp] === uid;
    };
}
exports.kind = kind;
